// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "CurveFitDoc.h"
#include "CurveFit.h"
#include "SetupCurveFitView.h"
#include "GraphView.h"
#include "CurveFitEditView.h"
#include "MainFrm.h"
#include "..\IniFile.h"
#include "Splash.h"

extern CIniFile *IniFile;
 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	// O[o wv R}h
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

    LoadBarState ("BarSettings");

	// CG: ȉ̃ubN̓XvbV XN[ R|[lgɂĒǉ܂
	CSplashWnd::ShowSplashScreen(this);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB
	char str[256];
	IniFile->GetString("Window", "Position", "", str);
	if(*str != 0)
	{
		sscanf(str, "%d %d %d %d", &cs.x, &cs.y, &cs.cx, &cs.cy);
	}

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	int cxCur0, cxCur1, cyCur0, cyCur1;
	cxCur0 = IniFile->GetInt("Window", "ColumnWidth0", 350);
	cxCur1 = IniFile->GetInt("Window", "ColumnWidth1", 200);
	cyCur0 = IniFile->GetInt("Window", "RowHeight0", 100);
	cyCur1 = IniFile->GetInt("Window", "RowHeight1", 100);
	if(!m_wndSplitter.CreateStatic(this, 1, 2) ||
		!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CSetupCurveFitView),
								CSize(cxCur0, 100), pContext) ||
	    !m_wndSplitter2.CreateStatic(&m_wndSplitter, 2, 1,
					WS_CHILD|WS_VISIBLE, m_wndSplitter.IdFromRowCol(0, 1)) ||
		!m_wndSplitter2.CreateView(0, 0, RUNTIME_CLASS(CGraphView),
								CSize(cxCur1, cyCur0), pContext) ||
		!m_wndSplitter2.CreateView(1, 0, RUNTIME_CLASS(CCurveFitEditView),
								CSize(cxCur1, 0), pContext)
								) 
	{
		TRACE0("Can't create splitter window\n");
		return FALSE;
	}
	return TRUE;
//	return CFrameWnd::OnCreateClient(lpcs, pContext);
}

void CMainFrame::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	char str[256];
	WINDOWPLACEMENT wp;
	wp.length = sizeof(wp);
	GetWindowPlacement(&wp);
	sprintf(str, "%d %d %d %d", wp.rcNormalPosition.left, wp.rcNormalPosition.top,
		wp.rcNormalPosition.right-wp.rcNormalPosition.left,
		wp.rcNormalPosition.bottom-wp.rcNormalPosition.top);
	IniFile->WriteString("Window", "Position", str);

	int i;
	for(i = 0 ; i < m_wndSplitter.GetColumnCount() ; i++)
	{
		int cxCur, cxMin;
		m_wndSplitter.GetColumnInfo(i, cxCur, cxMin);
		char s[256];
		sprintf(s, "ColumnWidth%d", i);
		IniFile->WriteInt("Window", s, cxCur);
	}
	for(i = 0 ; i < m_wndSplitter2.GetRowCount() ; i++)
	{
		int cyCur, cyMin;
		m_wndSplitter2.GetRowInfo(i, cyCur, cyMin);
		char s[256];
		sprintf(s, "RowHeight%d", i);
		IniFile->WriteInt("Window", s, cyCur);
	}

    SaveBarState ("BarSettings");
	
	CFrameWnd::OnClose();
}

int CMainFrame::SwitchToView(int nView)
{
/*
	CView *pActiveView =  GetActiveView();
	CCurveFitDoc *pDoc = (CCurveFitDoc*)pActiveView->GetDocument();
	CView* pOldActiveView;
	if(m_nView == 0) pOldActiveView = pDoc->GetMeasureConditionView();
	else if(m_nView == 1) pOldActiveView = pDoc->GetMeasureTimeIConditionView();
	else if(m_nView == 2) pOldActiveView = pDoc->GetMeasureCyclicIVView();
	if(pOldActiveView == NULL) return -1;

	CView* pNewActiveView = (CView*)GetDlgItem(nView);
	RECT rt;
	if(pNewActiveView == NULL)
	{
		switch(nView)
		{
		case 0:
			pNewActiveView = (CView*) new CMeasureConditionView;
			break;
		case 1:
			pNewActiveView = (CView*) new CMeasureTimeIConditionView;
			break;
		case 2:
			pNewActiveView = (CView*) new CMeasureCyclicIVView;
			break;
		}
		if(pNewActiveView == NULL)
		{
			MessageBox("Can't create View", "Error in CMainFrame::SwitchToView");
			return -1;
		}
		CCreateContext context;
		context.m_pCurrentDoc = pOldActiveView->GetDocument();
		(m_wndSplitter.GetPane(0,0))->GetWindowRect(&rt);
		rt.bottom = rt.bottom-rt.top;
		rt.top = 0;
		rt.right = rt.right-rt.left;
		rt.left = 0;
		pNewActiveView->Create(NULL, NULL, 0L,  rt, &m_wndSplitter, nView, &context);
		pNewActiveView->OnInitialUpdate();
	}
	SetActiveView(pNewActiveView);
	pNewActiveView->ShowWindow(SW_SHOW);
	pOldActiveView->ShowWindow(SW_HIDE);
	if(pOldActiveView->GetRuntimeClass() == RUNTIME_CLASS(CMeasureConditionView))
		pOldActiveView->SetDlgCtrlID(0);
	else if(pOldActiveView->GetRuntimeClass() == RUNTIME_CLASS(CMeasureTimeIConditionView))
		pOldActiveView->SetDlgCtrlID(1);
	else if(pOldActiveView->GetRuntimeClass() == RUNTIME_CLASS(CMeasureCyclicIVView))
		pOldActiveView->SetDlgCtrlID(2);
	pNewActiveView->SetDlgCtrlID(AFX_IDW_PANE_FIRST);
	RecalcLayout();
	if(nView == 0) ((CMeasureConditionView*)pNewActiveView)->Resize();
	else if(nView == 1) ((CMeasureTimeIConditionView*)pNewActiveView)->Resize();
	else if(nView == 2) ((CMeasureCyclicIVView*)pNewActiveView)->Resize();
	return m_nView = nView;
*/
	return 0;
}

